package com.zkc.Service;

import java.io.InputStream;
import java.io.UnsupportedEncodingException;

import com.zkc.barvodeScan.MainActivity;
import com.zkc.beep.ServiceBeepManager;
import com.zkc.io.EmGpio; 
import com.zkc.pc700.helper.ScanGpio;
import com.zkc.pc700.helper.SerialPort;

import android.app.Application;
import android.app.Service;
import android.content.Intent;
import android.os.Handler;
import android.os.IBinder;
import android.os.Message;
import android.util.Log;
import android.widget.Toast;

public class CaptureService extends Service {

	private static final String TAG = "CaptureService";
	private ServiceBeepManager beepManager;// ɨɹʾ
	private byte[] leaveSetting = new byte[] { 0x04, (byte) 0xC8, 0x04, 0x00,
			(byte) 0xFF, 0x30 };// 

	private byte[] packedData = new byte[] { 0x07, (byte) 0xC6, 0x04, 0x08,
			0x00, (byte) 0xEB, 0x07, (byte) 0xFE, 0x35 };// ȡݸʽ 
	public static SerialPort serialPort;
	private InputStream mInputStream;// ȡϢ
	private String choosed_serial = "/dev/ttyMT0";// ں
	private int choosed_buad = 9600;// 
	private ReadThread readThread;// ȡϢ߳
	private static byte[] getbuffer = new byte[1024];// Ϣ
	private static int getsize = 0;// Ϣ 
	public static ScanGpio scanGpio = new ScanGpio();

	@Override
	public IBinder onBind(Intent intent) {
		Log.v(TAG, "CaptureService onBind");

		return null;
	}

	/**
	 * ȡϢ
	 * 
	 * @author zkc-soft2
	 * 
	 */
	class ReadThread extends Thread {

		@Override
		public void run() {

			while (!interrupted()) {
				try {

					int size;
					byte[] buffer = new byte[1024];

					if (mInputStream == null)
						return;
					// ȡϢ
					size = mInputStream.read(buffer);
					Log.v(TAG, size + "");
					// ȡϢ
					for (int i = 0; i < size; i++) {
						getbuffer[getsize + i] = buffer[i];
					}
					// Ϣ
					getsize += size;
					handler.post(new Runnable() {

						@Override
						public void run() {
							// TODO Auto-generated method stub
							Message m = new Message();
							m.arg1 = getsize;
							m.obj = getbuffer;
							handler.sendMessage(m);
						}
					});
				} catch (Exception e) {
					e.printStackTrace();

					return;
				}
			}

		}
	}

	/**
	 * ʾϢHandle
	 */
	Handler handler = new Handler() {

		@Override
		public void handleMessage(Message msg) {
			// TODO Auto-generated method stub
			byte[] getdata = (byte[]) msg.obj;
		
			int sizs = msg.arg1;
			byte[] setData =new byte[sizs];
			boolean isfull = false;// Ƿȡ
			boolean isLuanMa=false;//״Ƿݡ4, -48, 0, 0, -1, 44
			
			for (int i = 0; i < sizs; i++) {
				setData[i]=getdata[i];
				if (getdata[i] == 13) {
					isfull = true;
				}
				if (getdata[i]==-1) {
					isLuanMa=true;
				}
			}
			
			if (isfull) {
				// ɨɹʾ
				beepManager.playBeepSoundAndVibrate();
				MainActivity.isScanOpen = false;
				try {
					String getStringPort;
					// תɨϢΪַʽUTF-8
					if (isLuanMa) {						 
						 setData =new byte[sizs];
						for (int j = 6; j < sizs; j++) {
							setData[j-6]=getdata[j];
						}
						  getStringPort = new String(setData, 0, sizs, "UTF-8");
					}else {
						  getStringPort = new String(setData, 0, sizs, "UTF-8");
					}
					Log.d(TAG, getStringPort);
					
				 	MainActivity.et_code.setText(getStringPort);
				 
				} catch (Exception e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}

	};
 
	@Override
	public void onCreate() {
		super.onCreate();
		Log.v(TAG, "CaptureService onCreate");
		 
		// ʾ
		beepManager = new ServiceBeepManager(this);
		beepManager.updatePrefs();
		try {
			//򿪵Դ
			scanGpio.openPower();
			// Ӵ
			serialPort = new SerialPort(choosed_serial, choosed_buad, 0);
			mInputStream = serialPort.getInputStream();
			
			// ýոʽ
			serialPort.send_Instruct(packedData);
			// ȡϢ
			readThread = new ReadThread();
			readThread.start();
		} catch (Exception e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}

	}
	public static void  clerkMessage(){
		getsize = 0;// ɨϢ0
		getbuffer = new byte[1024];// ɨϢ
	}
	@Override
	public void onStart(Intent intent, int startId) {
		Log.v(TAG, "CaptureService onStart");
		super.onStart(intent, startId);
	 
		
		
		if (MainActivity.isStartOpen) {
			MainActivity.isStartOpen=false;
			//ı
		if (MainActivity.et_code!=null) {
			MainActivity.et_code.setText("");
		}
		//ݣɨ
		CaptureService.clerkMessage();
		CaptureService.scanGpio.openScan();
 
		new Thread(new Runnable() {
			
			@Override
			public void run() {
				// TODO Auto-generated method stub
				try {
					Thread.sleep(3000);
				} catch (InterruptedException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
				MainActivity.isScanOpen = false;
			}
		}).start();
		
		}
	}

	@Override
	public void onDestroy() {
		// TODO Auto-generated method stub
		Log.v(TAG, "CaptureService onDestroy");

		if (readThread != null) {
			readThread.interrupt();
			serialPort = null;
		}
		super.onDestroy();
	}

}
